#include <iostream>
#include <string> 
using namespace std;

struct point {
   double x,y;
};

inline ostream& operator <<( ostream& stream, struct point& obj ) {
      return stream << "<" <<  obj.x << ";" << obj.y << ">"; 
};

inline istream& operator >>( istream& stream, struct point& obj ) {
   double x, y;
   string s;
   if( ( cin >> x ).eof() ) return stream;  // ввод X
   if( cin.rdstate() & ios::failbit ) {
      cerr << "ошибка ввода X!" << endl;
      cin.clear();
      getline( cin, s );
      return stream;
   }
   if( ( cin >> y ).eof() ) return stream;  // ввод Y
   if( cin.rdstate() & ios::failbit ) {
      cerr << "ошибка ввода Y!" << endl;
      cin.clear();
      getline( cin, s );
      return stream;
   }
   getline( cin, s );
   if( !s.empty() ) {                       // если введено больше 2-значений
      basic_string<char>::iterator i;
      for( i = s.begin(); i != s.end() && *i == ' '; i++ );
      if( i != s.end() ) {                  // если там непробельные символы
         cerr << "ошибка ввода: " << s << endl;
         return stream;
      }
   }
   obj.x = x;
   obj.y = y;
   return stream; 
};

int main( int argc, char **argv ) {
   while( true ) {
      cout << "координаты X и Y: " << flush;
      struct point pt = { 0, 0 };
      cin >> pt;
      if( cin.eof() ) { cout << endl; break; }
      cout << "введена 2D точка: " << pt << endl;
   }
   return 0;
}
