#include <fstream>
#include <iostream>
using namespace std;

int main( int argc, char* argv[] ) {
   if( argc != 3 ) {
      cout << "using: " << argv[ 0 ] 
           << " <file_input> <file_output>" << endl;
      return 1; 
   }
   ifstream fi;
   fi.open( argv[ 1 ] );
   if( !fi.is_open() ) {
      cerr << "can't open input file " << argv[ 1 ] << endl;
      return 1; 
   };
   ofstream fo;
   fo.open( argv[ 2 ] );
   if( !fo.is_open() ) {
      cerr << "can't create output file " << argv[ 2 ] << endl;
      return 1; 
   };
   char c;
   while( fi.get( c ) ) 
      fo.put( c );
   fi.close();
   fo.close();
   return 0; 
}
